#include <avr/io.h>
#include <util/delay.h>

#define F_CPU 16000000
#define SERVO_DEFAULT 400
#define LEFT (1)
#define RIGHT (-1)
#define REV_MAX 0
#define SPEED_MAX 255
volatile char command = 'Z';
short int myval;
char bufc;
int steer = 1;
int direction = 1;
int CURRENT_A;
int CURRENT_B;
int stationary = 1;
void Servo_init()
{
	TCCR1A |= (1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);
	TCCR1B |= (1<<WGM13)|(1<<WGM12)|(1<<CS11)|(1<<CS10);
	DDRD |= (1<<PD4)|(1<<PD5);
}

void full_speed_front()
{
	OCR0A = SPEED_MAX;
}

void full_speed_rev()
{
	OCR0A = REV_MAX;
}

void brake()
{
	OCR0A = SPEED_MAX;
	OCR0B = 0;
}

void go_forward()
{
	OCR0B = OCR0A = CURRENT_A = 190;

}
void go_back()
{
	OCR0A = OCR0B = SPEED_MAX - 240;
}
void set_gear(char gear)
{
	switch(gear)
	{
	case '1':CURRENT_A = CURRENT_B = 170; break;
	case '2':CURRENT_A = CURRENT_B = 190; break;
	case '3':CURRENT_A = CURRENT_B = 210; break;
	case '4':CURRENT_A = CURRENT_B = 230; break;
	case '5':CURRENT_A = CURRENT_B = SPEED_MAX; break;
	default: break;
	}

}

void Engine_init()
{
	TCCR0A |= (1<<WGM00);
	TCCR0A |= (1<<COM0A1);
	TCCR0A |= (1<<COM0B1);
	TCCR0B |= (1<<CS02);
	direction = 1;
	DDRB |= (1<<PB3) | (1<<PB4);
	brake();
	}
void Bluetooth_init()
{
	/* set baud rate to 9600 */
	UBRR1H = 0;
	UBRR1L = 103;

	/* start transmitter and receiver */
	UCSR1B = (1<<RXEN1);

	/* set frame format: 8 data bits, 1 stop bit, no parity */
	UCSR1C = (3<<UCSZ10);
	// UCSR1C |= (2<<UCSZ00);
	// UCSR1C |= (1<<UPM01);
}
char Bluetooth_receive()
{
	while(!(UCSR1A & (1<<RXC1)));
	return UDR1;
}

void release_wheel()
{
	OCR1A = ICR1;
	OCR1B = 0;
}

void go_right()
{
	OCR1A = 300;
	OCR1B = 300;
}

void go_left()
{
	OCR1A = 4500;
	OCR1B = 4500;
}
void parse_action(char command)
{
	switch(command)
	{
		case '1': set_gear(command);
		case '2': set_gear(command);
		case '3': set_gear(command);
		case '4': set_gear(command);
		case '5': set_gear(command); break;
		case 'P': brake(); break;
		case 'F': go_forward(); break;
		case 'S': brake(); break;
		case 'B': go_back(); break;
		case 'L': go_left(); break;
		case 'R': go_right(); break;
		case 'N': release_wheel(); break;
		default: break;
	}

}

int main()
{
	Bluetooth_init();
	Servo_init(); // inca avem de munca aici;
	Engine_init();
	DDRA &= ~(1<<PA0);
	DDRA |= (1<<PA0);
	//DDRA |= (1<<PA1);
	//DDRA |= (1<<PA6);
	//DDRA |= (1<<PA7);
	DDRB |= (1<<PB0);
	DDRD |= (1<<PD0);
	DDRD |= (1<<PD2);
	PORTA |= (1<<PA0);
	PORTB |= (1<<PB0);

	//OCR0A = -250;
	//_delay_ms(3000);
	//OCR0A = -50;
	//_delay_ms(3000);
	//OCR0A = 0;
	//_delay_ms(3000);
	//OCR0A = 150;
	//_delay_ms(3000);
	//PORTA &= (1<<PA1);
	//PORTA &= ~(1<<PA4);
	//PORTA &= ~(1<<PA5);
	/* nu face nimic */
	//PORTA |= (1<<PA4); /* se duce in stanga, cu fata */
	//PORTA |= (1<<PA5); /* se duce in stanga, cu fata */
	//full_speed_front();
	//_delay_ms(2000);
	//full_speed_rev();
	//_delay_ms(2000);
	//sudden_death();
	//set_gear('1');
	//go_forward();
	//_delay_ms(1000);
	//set_gear('2');
	//go_forward();
	//_delay_ms(1000);
	//set_gear('3');
	//go_forward();
	//_delay_ms(1000);
	//set_gear('4');
	//go_forward();
	//_delay_ms(1000);
	//set_gear('5');
	//go_forward();
	//_delay_ms(1000);
	//brake();
	//go_forward();
	//OCR1A = 4000;
	//OCR1B = 0;
	//ICR1 = 0;
	//OCR1A = 0;
	//_delay_ms(2000);
	//ICR1 = 0xFFFF;
	//_delay_ms(2000);
	ICR1 = 4999;
	release_wheel();
	_delay_ms(2000);
	//go_left();
	//_delay_ms(2000);
	//release_wheel();
	//_delay_ms(2000);
	//go_right();
	//_delay_ms(2000);
	//release_wheel();
	//_delay_ms(2000);
	//go_left();
	//_delay_ms(2000);
	//release_wheel();






	while (1) {
		//release_wheel();
		command = Bluetooth_receive();
		if (command != 'Z')
			parse_action(command);
	//	//PORTA |= (1<<PA4); /* se duce in dreapta, cu spatele */
	//	//PORTA |= (1<<PA5); /* se duce in dreapta, cu spatele */
	//	//_delay_ms(3000);

	//	//PORTA |= (1<<PA4); /* se duce in dreapta, cu spatele */
	//	//PORTA ^= (1<<PA5); /* se duce in dreapta, cu spatele */
	//	//_delay_ms(3000);
	//	////PORTA ^= (1<<PA5); /* xor pe PA5 => frana brusca */
	//	//PORTA ^= (1<<PA4); /* se duce in dreapta, cu spatele */
	//	//PORTA |= (1<<PA5); /* se duce in dreapta, cu spatele */
	//	//_delay_ms(3000);
	//	////PORTA ^= (1<<PA5); /* xor pe PA5 => frana brusca */
	//	//PORTA |= (1<<PA4); /* se duce in dreapta, cu spatele */
	//	//PORTA ^= (1<<PA5); /* se duce in dreapta, cu spatele */
	//	//_delay_ms(3000);
	//	//if (command == 'D')
	//	//	OCR1A = SERVO_DEFAULT;
	//	//PORTA ^= (1<<PA4); /* se duce in dreapta, cu spatele */
	//	//PORTA &= ~(1<<PA4);
	//	//PORTA &= ~(1<<PA5);
	//	///PORTA &= ~(1<<PA5);
	}
	return 0;
}
